<template>
    <form @submit.prevent="onSubmit" class="space-y-4">
        <div class="flex gap-32">
            <div class="flex-1 space-y-4">
                <div class="form-control">
                    <label class="flex flex-col" for="name">
                        <div>
                            Tên bài học <span class="text-red-500">*</span>
                        </div>
                        <input
                            v-model="data.name"
                            id="name"
                            type="text"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                            :class="{ 'border-red-400': dataErrors.name }"
                        />
                    </label>
                    <div
                        v-if="dataErrors.name"
                        class="text-left text-sm text-red-500 mt-1"
                    >
                        {{ dataErrors.name }}
                    </div>
                </div>

                <div class="form-control">
                    <label class="flex flex-col" for="type">
                        <div>
                            Kiểu bài học <span class="text-red-500">*</span>
                        </div>
                        <select
                            v-model="data.type"
                            id="type"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2.5"
                            :class="{ 'border-red-400': dataErrors.type }"
                        >
                            <option disabled value="">Chọn kiểu bài học</option>
                            <option
                                :key="type.id"
                                v-for="type in SELECT_OPTION_TYPE_LESSON"
                                :value="type.id"
                            >
                                {{ type.text }}
                            </option>
                        </select>
                    </label>
                    <div
                        v-if="dataErrors.type"
                        class="text-left text-sm text-red-500 mt-1"
                    >
                        {{ dataErrors.type }}
                    </div>
                </div>

                <div class="form-control">
                    <label class="flex flex-col" for="order">
                        <div>Sắp xếp</div>
                        <input
                            v-model.number="data.order"
                            id="order"
                            type="number"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                            :class="{ 'border-red-400': dataErrors.order }"
                            placeholder="Số nguyên..."
                        />
                    </label>
                </div>
            </div>

            <div class="flex-1">
                <div class="form-control">
                    <div>Hình ảnh</div>
                    <div class="flex items-center gap-5 mt-1">
                        <UploadButton v-model:urlImage="data.image" />
                        <div id="image" class="relative w-48">
                            <div
                                v-show="data.image"
                                @click="onDeleteImage"
                                class="absolute top-0 right-0 cursor-pointer"
                            >
                                <Tooltip text="Xóa ảnh">
                                    <XCircleIcon class="h-8 w-8" />
                                </Tooltip>
                            </div>
                            <img v-show="data.image" :src="data.image" alt="" />
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="description">
                <div class="mb-1">Mô tả bài học</div>
                <QuillEditor
                    id="description"
                    v-model:content="data.description"
                />
            </label>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="content">
                <div class="mb-1">
                    Nội dung bài học <span class="text-red-500">*</span>
                </div>
                <QuillEditor id="content" v-model:content="data.content" />
            </label>
            <div
                v-if="dataErrors.content"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.content }}
            </div>
        </div>

        <div class="form-control flex items-center gap-3">
            <BasicButton type="submit">
                {{ isUpdate ? "Cập nhật" : "Tạo" }}
            </BasicButton>
            <LinkButton
                nameRoute="teacher-course-view"
                :paramsRoute="{ courseId }"
                hashRoute="#lessons"
                classCustom="bg-color-danger hover:shadow-hover-danger"
            >
                Hủy
            </LinkButton>
        </div>
    </form>
</template>

<script>
import { reactive, ref } from "vue";
import { useRouter } from "vue-router";
import { createToast } from "mosha-vue-toastify";
import { SELECT_OPTION_TYPE_LESSON } from "@/constants";

import useCreateLesson from "@/hooks/lesson/useCreateLesson";
import useUpdateLesson from "@/hooks/lesson/useUpdateLesson";

import { XCircleIcon } from "@heroicons/vue/outline";
import QuillEditor from "@/components/quill-editor/QuillEditorVue3.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";
import UploadButton from "@/components/button/UploadButton.vue";
import Tooltip from "@/components/tooltip/Tooltip.vue";

export default {
    components: {
        XCircleIcon,
        QuillEditor,
        BasicButton,
        LinkButton,
        UploadButton,
        Tooltip
    },
    props: {
        courseId: {
            type: Number,
            required: true
        },
        lesson: {
            type: Object
        }
    },
    setup(props) {
        const router = useRouter();
        const isUpdate = ref(props.lesson ? true : false);
        const { errorResponse, onCreateLesson } = useCreateLesson();
        const { errorResponseUpdate, onUpdateLesson } = useUpdateLesson();

        const data = reactive({
            course_id: props.courseId ? props.courseId : null,
            name: props.lesson ? props.lesson.name : "",
            type: props.lesson ? props.lesson.type : "",
            order: props.lesson ? props.lesson.order : "",
            image: props.lesson?.image ? props.lesson.image : "",
            description: props.lesson?.description
                ? props.lesson.description
                : "",
            content: props.lesson?.content ? props.lesson.content : ""
        });

        const dataErrors = reactive({
            name: null,
            type: null,
            content: null
        });

        function onDeleteImage() {
            data.image = "";
        }

        async function onSubmit() {
            dataErrors.name = null;
            dataErrors.type = null;
            dataErrors.content = null;

            let input_valid = true;
            // check empty input
            if (
                !data.course_id ||
                !data.name ||
                data.type === "" ||
                !data.content
            ) {
                input_valid = false;
                if (!data.course_id) {
                    createToast(
                        "Đã có lỗi xảy ra, bạn thử refresh lại trang nhé",
                        {
                            showIcon: true,
                            type: "danger"
                        }
                    );
                }
                if (!data.name) dataErrors.name = "Bạn chưa nhập tên bài học";
                if (data.type === "")
                    dataErrors.type = "Bạn chưa chọn kiểu bài học";
                if (!data.content)
                    dataErrors.content = "Bạn chưa nhập nội dung bài học";
            }

            // check input valid and submit form
            if (input_valid) {
                // show loading
                document.getElementById("full-page-loading").style.display =
                    "block";

                if (isUpdate.value) {
                    await onUpdateLesson(props.lesson.id, data);
                } else {
                    await onCreateLesson(data);
                }

                // hide loading
                document.getElementById("full-page-loading").style.display =
                    "none";

                // check error from server
                if (errorResponse.value || errorResponseUpdate.value) {
                    if (errorResponseUpdate.value) {
                        errorResponse.value = errorResponseUpdate.value;
                    }
                    if (
                        errorResponse.value.name &&
                        errorResponse.value.name.length
                    ) {
                        dataErrors.name = errorResponse.value.name[0];
                    }
                    if (
                        errorResponse.value.type &&
                        errorResponse.value.type.length
                    ) {
                        dataErrors.type = errorResponse.value.type[0];
                    }
                    if (
                        errorResponse.value.is_sequence &&
                        errorResponse.value.is_sequence.length
                    ) {
                        dataErrors.is_sequence =
                            errorResponse.value.is_sequence[0];
                    }
                } else {
                    createToast(
                        isUpdate.value
                            ? "Cập nhật bài học thành công"
                            : "Thêm bài học thành công",
                        {
                            showIcon: true,
                            type: "success"
                        }
                    );
                    router.push({
                        name: "teacher-course-view",
                        params: { courseId: props.courseId },
                        hash: "#lessons"
                    });
                }
            }
        }

        return {
            SELECT_OPTION_TYPE_LESSON,
            isUpdate,
            data,
            dataErrors,
            onDeleteImage,
            onSubmit
        };
    }
};
</script>

<style lang="scss" scoped>
#image > div {
    transform: translate(45%, -45%);
}
</style>
